/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 653 $ $LastChangedDate: 2002-08-28 22:21:29 +0200 (Wed, 28 Aug 2002) $
 *
 * Standard library for Gont, Hashtbl module interface.
 *
 * Mutable hashtable.
 */

type <'a>t;

<'a>t create(int size_hint);

// can raise Not_found
'a find(<'a>t, string);
void remove(<'a>t h, string k);
// this cannot
<'a>list find_all(<'a>t, string);
void remove_all(<'a>t h, string k);
bool mem(<'a>t, string);
void add(<'a>t, string, 'a);
void iter(<'a>t h, *(void (string, 'a)) f);
<'a>t copy(<'a>t);
int length(<'a>t h);

int prime_around(int) = "Hashtbl__prime_around";
